typedef struct term *term;
typedef struct int_ptr *intlist;

#define MAX_BUILTINS  256
#define FUNCTOR(t)  (t->sym_num)
#define VARNUM(t)   (t->varnum)
#define ARG0(t)     (t->farg->argval)
#define ARG1(t)     (t->farg->narg->argval)
#define TYPE(t)     (t->type)

struct term *True(struct literal *);
struct term *False(struct literal *);
int isFalse(struct term *);
int isTrue(struct term *);
void argrep(term t, int n, term newarg);
term arg(int i, term t);
int arity(term t);

term lambda(term, term);
term cases(term,term,term,term);
term ap(term,term);
term otter_or(term,term);

int set_vars2(struct term *t, int *nextvar);  
